# CGI-Library
#
# 11.01.97 Jonas Sextl

sub HtmlStart {
	local ($title, $back) = @_;

	print <<EOF;
<html>
<head>
<title>$title</title>
</head>
<body background=\"$back\">
EOF
	return;
}

sub HtmlEnd {
	print <<EOF;
<br>
		<hr>
                <table>
                        <tr>
                        <td>
                        &copy; 
                        </td>
                        <td> 1997 by Jonas Sextl, last modified: 12.01.97
                        </td>
                        <tr>
                        <td> </td>
                        <td>
                        Bei Problemen, Fragen, Anregungen bitte eine Mail an :
			<adress><a href="mailto:jonny\@dillingen.baynet.de"> 
                        jonny\@dillingen.baynet.de </a>!
                </table>
EOF
	return "</body>\n</html>\n";
}

sub url_encode {
	local ($s) = @_;
	
	$s =~ s|([+<>%"/?=&])|sprintf("%%%02X", ord($1))|ge;
	$s =~ tr/ /+/;
	$s;
}

sub url_decode {
	local ($s) = @_;

	$s =~ tr/+/ /;
	$s =~ s/%([0-9A-F][0-9A-F])/pack("C", oct("0x$1"))/ge;
	$s;
}

sub cgiparse {
	local ($data) = @_;

	if(defined $data) {
	}
	elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
		local($len)=$ENV{'CONTENT_LENGTH'};
		if(read(STDIN, $data, $len) != $len) {
			die("Error reading 'POST' data\n");
		}
	}
	else {
		$data = $ENV{'QUERY_STRING'};
	}

	local(%qs) = ();

	foreach $qs (split('&', $data)) {
		local($name, $val) = split('=', $qs);
		$name = &url_decode($name);
		if(defined $qs{$name}) {
			$qs{$name} .= "\0" . &url_decode($val);
		}
		else {
			$qs{$name} = &url_decode($val);
		}
	}

	%qs;
}

sub printheader {
	print "Content-type: text/html\n\n";
}

sub getspnam {
	local($user) = @_;

	open(SHADOW, '/etc/shadow');
	
	if(SHADOW) {
		while(<SHADOW>) {
			if (/^$user:(\S*):(\S*):(\S*):(\S*):(\S*):(\S*):(\S*):(\S*)$/) {
				$spwd = $1;
			}
		}
		return $spwd;
	} else {
		return 0;
	}
}

sub checkusersystem {
        local($user, $passwd) = @_;

	if (!($pwd=getspnam($user))) {
        	$pwd = (getpwnam($user)) [1];
	}

	if(!$pwd) {
		return 0;
	}

        $salt = substr($pwd, 0, 2);
        if(crypt($passwd, $salt) ne $pwd) {
                return 0;
        } else {
                return 1;
        }
}

sub checkuser {
        local($user, $passwd) = @_;

	$pwd = $superpasswd;

        $salt = substr($pwd, 0, 2);
        if(crypt($passwd, $salt) ne $pwd) {
                return 0;
        } else {
                return 1;
        }
}

sub checklocal {
	local(%request) = ();

	unless(defined $ENV{'SCRIPT_NAME'} ) {
		print STDOUT ("$0 nicht ueber den server gestartet!\n");
		if(@ARGV>0) {
			print STDOUT ("Benutze Argv[].\n");
			$request = join('&', @ARGV);
		}
		else {
			print STDOUT ("Bitte geben Sie name/value Paare ein.\n");
			while (<>) {
				chop;
				$request .= $_ . '&';
			}
			chop($request);
		}
	}
	%request = &cgiparse($request);
	return %request;
}

sub execute {
        local($args) = @_;

        system split / /, $args;
}

1;
